Opened 13 years ago

Closed 13 years ago

Last modified 13 years ago

#1065 closed defect (fixed)

[patch][cla] Dojo unloads from hosted IE control

Reported by: sol@… Owned by: dylan
Priority: high Milestone: 0.9
Component: General Version: 0.3
Keywords: ie unload Cc:
Blocked By: Blocking:

Description

Dojo incorrectly unloads when visibility of the IE (WebBrowser? ActiveX control) hosted in an application changes. IE fires "unload" event when it becomes invisible, in addition to when the page unloads. When later control is shown again, Dojo is unloaded and page is unusable. This problem is documented here: http://support.microsoft.com/default.aspx?scid=kb;en-us;199155

This problem makes it nearly impossible to use dojo with a hosted IE control.

The solution would be to listen to "beforeunload" events (fired only when page is being unloaded) and allow dojo to unload only if it was fired. Could this create a conflict with Dojo back button support?

Attachments (3)

dojo_unload.patch (1005 bytes) - added by sol@… 13 years ago.
Patch with the fix to the unload problem
dojo_unload.2.patch (1.0 KB) - added by ornus 13 years ago.
Updated patch
dojo_unload.3.patch (401 bytes) - added by ornus 13 years ago.
patch with the fix. only one unload is present

Download all attachments as: .zip

Change History (11)

Changed 13 years ago by sol@…

Attachment: dojo_unload.patch added

Patch with the fix to the unload problem

comment:1 Changed 13 years ago by dylan

Owner: changed from anonymous to dylan
Status: newassigned

Sol, looks like a good patch, but we need a CLA in order to consider it.

comment:2 Changed 13 years ago by ornus

Hey, my name Slava Ivanyuk. CCLA for the company I'm with (Emerald Hand, Inc.) was submitted and accepted by Carrie Sacket, so this shouldn't be a problem.

I'm going to go ahead and attach an updated patch.

Changed 13 years ago by ornus

Attachment: dojo_unload.2.patch added

Updated patch

comment:3 Changed 13 years ago by dylan

Summary: Dojo unloads from hosted IE control[patch][cla] Dojo unloads from hosted IE control

comment:4 Changed 13 years ago by dylan

Resolution: fixed
Status: assignedclosed

(In [6092]) fix unload for using Dojo in a host IE control, fixes #1065

comment:5 Changed 13 years ago by ornus

Resolution: fixed
Status: closedreopened

the fix you have implemented doesn't work as intended. you call dojo.hostenv.unloaded(); twice in the window unload handler. there should only be one call to it inside of the "if"

comment:6 Changed 13 years ago by bill

Milestone: 0.40.5

Changed 13 years ago by ornus

Attachment: dojo_unload.3.patch added

patch with the fix. only one unload is present

comment:7 Changed 13 years ago by dylan

Resolution: fixed
Status: reopenedclosed

(In [6933]) fixes #1065

comment:8 Changed 13 years ago by alex

Resolution: fixed

(In [6938]) Merged revisions 6902-6937 via svnmerge from svn+ssh://alex@svn.dojotoolkit.org/var/src/dojo/trunk

........

r6903 | alex | 2006-12-15 05:17:24 -0800 (Fri, 15 Dec 2006) | 2 lines

adding a parameter to allow for asynchronous stylesheet loading. Defaults to "false"

........

r6904 | peller | 2006-12-15 13:29:42 -0800 (Fri, 15 Dec 2006) | 1 line

add task to build api ref app

........

r6905 | BryanForbes? | 2006-12-16 13:09:16 -0800 (Sat, 16 Dec 2006) | 1 line

DOM Node expandos or properties are a no-no. Changed dojoDisplayCache property to djDisplayCache attribute to prevent leaks for sure.

........

r6906 | jkuhnert | 2006-12-16 13:46:49 -0800 (Sat, 16 Dec 2006) | 1 line

Added ability for required check to check input types of "file" .

........

r6907 | liucougar | 2006-12-16 18:17:14 -0800 (Sat, 16 Dec 2006) | 1 line

deprecated--

........

r6908 | peller | 2006-12-17 14:01:41 -0800 (Sun, 17 Dec 2006) | 1 line

Fixes #2213

........

r6909 | peller | 2006-12-17 14:04:52 -0800 (Sun, 17 Dec 2006) | 1 line

References #2213

........

r6910 | pottedmeat | 2006-12-17 17:06:27 -0800 (Sun, 17 Dec 2006) | 1 line

Make RichText? parse

........

r6911 | bill | 2006-12-18 00:46:51 -0800 (Mon, 18 Dec 2006) | 6 lines

Fixes #2174 (clicking a radio button that is "checked" shouldn't "uncheck" the radio button)

I removed the preventDefault() call for non-a11y checkbox onClick(); images don't have a default handler for clicks anyway. (They aren't like <a>) I don't see a reason for the stopPropogation() call either but I left it in for now.

........

r6912 | alex | 2006-12-18 04:43:53 -0800 (Mon, 18 Dec 2006) | 2 lines

forgot to update this when we tagged 0.4.1

........

r6913 | liucougar | 2006-12-18 14:17:26 -0800 (Mon, 18 Dec 2006) | 1 line

cleanup and improve performance of Editor2Dialog

........

r6914 | elazutkin | 2006-12-18 16:19:01 -0800 (Mon, 18 Dec 2006) | 1 line

bugfix: our togglers are stateful now --- we have to clone them.

........

r6915 | pottedmeat | 2006-12-18 22:30:44 -0800 (Mon, 18 Dec 2006) | 1 line

Update to help ApiRef? with remote JSON

........

r6916 | pottedmeat | 2006-12-18 22:40:54 -0800 (Mon, 18 Dec 2006) | 1 line

Fixes #2077. No longer used

........

r6917 | pottedmeat | 2006-12-18 22:42:17 -0800 (Mon, 18 Dec 2006) | 1 line

Fixes #1535. No longer used

........

r6918 | skinner | 2006-12-19 01:47:15 -0800 (Tue, 19 Dec 2006) | 1 line

Here's a new round of dojo.data code. Changed dojo.declare() initializer argument to fix DEPRECATED warning. Fixed array iteration to not use "for (obj in array)", which is brittle and breaks in environments where the Array prototype has been extended. Moved getIdentity() and findByIdentity() into a new Identity API, as per resolution from our meeting on 2006-10-03. In the Read API, changed isItemAvailable() to isItemLoaded(), and added methods loadItem() and getFeatures(), as per 2006-11-27 meeting with Adam. In the Read API, changed get() to getValue(), as per 2006-12-18 meeting with Mignon. Added new dojo.data.core.nestedTransaction file, offering optional mixin with modest nested transaction support. Updated old unit tests to match new APIs, and added a new test_compatiblity.js test file, to start moving towards running a single set of tests across all datastore implementations, rather than having separate tests for each datastore.

........

r6919 | peller | 2006-12-19 07:45:54 -0800 (Tue, 19 Dec 2006) | 1 line

Initial check-in of CLDR data v1.4

........

r6920 | peller | 2006-12-19 07:45:58 -0800 (Tue, 19 Dec 2006) | 1 line

Initial check-in of CLDR data v1.4

........

r6921 | peller | 2006-12-19 07:46:30 -0800 (Tue, 19 Dec 2006) | 1 line

add stylesheet to build calendar data from CLDR via XSLT

........

r6922 | elazutkin | 2006-12-19 14:15:21 -0800 (Tue, 19 Dec 2006) | 2 lines

1) Reverted toggle.js to its original (stateless) form. All methods modified to return an animation object, where applicable. 2) Added toggler.js, which declares classes similar toggle.js, but which maintain their internal state automatically.

........

r6923 | peller | 2006-12-19 21:20:47 -0800 (Tue, 19 Dec 2006) | 1 line

add saxon jar (MPL) to support cldr build target

........

r6924 | peller | 2006-12-19 21:22:56 -0800 (Tue, 19 Dec 2006) | 1 line

a couple improvements to CLDR output

........

r6925 | peller | 2006-12-20 09:43:08 -0800 (Wed, 20 Dec 2006) | 1 line

Fixes #2049

........

r6926 | peller | 2006-12-20 13:56:58 -0800 (Wed, 20 Dec 2006) | 1 line

remove dojo.regexp.escape in favor of dojo.string.escape

........

r6927 | peller | 2006-12-20 14:00:06 -0800 (Wed, 20 Dec 2006) | 1 line

add enhancements from dojo.regexp.escape to dojo.string.escape

........

r6928 | bill | 2006-12-20 14:59:05 -0800 (Wed, 20 Dec 2006) | 1 line

Fix comment. References #2223

........

r6929 | jburke | 2006-12-20 22:40:10 -0800 (Wed, 20 Dec 2006) | 1 line

Fixes #2196: now have a intern-strings option for things that do not use templatePath and templateCssPath. Also moved intern-strings from python into javascript

........

r6930 | bill | 2006-12-21 07:33:28 -0800 (Thu, 21 Dec 2006) | 1 line

Fix comment. References #2223.

........

r6931 | peller | 2006-12-21 20:13:01 -0800 (Thu, 21 Dec 2006) | 1 line

updates to calendar xslt; new number and currency xslts. Thanks to Wei Huang (IBM) for creating all three.

........

r6932 | peller | 2006-12-21 22:16:51 -0800 (Thu, 21 Dec 2006) | 1 line

use ant macros to replace script

........

r6933 | dylan | 2006-12-27 02:24:19 -0800 (Wed, 27 Dec 2006) | 1 line

fixes #1065

........

r6934 | dylan | 2006-12-27 22:26:07 -0800 (Wed, 27 Dec 2006) | 1 line

obvious IE performance improvement for charting from Bob Buffone of Nexaweb, thanks Bob

........

r6935 | peller | 2006-12-28 12:24:58 -0800 (Thu, 28 Dec 2006) | 1 line

a few more patches from Wei (Evan) Huang at IBM

........

r6936 | peller | 2006-12-28 18:44:37 -0800 (Thu, 28 Dec 2006) | 1 line

got xmlcatalog working for xslt; will now use local copy of dtd instead of making many web hits

........

r6937 | peller | 2006-12-29 08:00:56 -0800 (Fri, 29 Dec 2006) | 1 line

oops. fix local path reference

........

Note: See TracTickets for help on using tickets.